(*^

::[paletteColors = 128; 
	fontset = title, "Helvetica-Bold", 24, L2, center, bold, nohscroll;
	fontset = subtitle, "Helvetica-Bold", 18, L2, center, bold, nohscroll;
	fontset = subsubtitle, "Helvetica-Bold", 14, L2, center, bold, nohscroll;
	fontset = section, "Helvetica-Bold", 16, L2, bold, nohscroll, grayBox;
	fontset = subsection, "Helvetica-Bold", 13, L2, bold, nohscroll, blackBox;
	fontset = subsubsection, "Helvetica-Bold", 12, L2, bold, nohscroll, whiteBox;
	fontset = text, "Times-Roman", 12, L2, nohscroll;
	fontset = smalltext, "Times-Roman", 10, L2, nohscroll;
	fontset = input, "Courier-Bold", 12, L2, bold, nowordwrap;
	fontset = output, "Courier", 12, L2, nowordwrap;
	fontset = message, "Courier", 12, L2, R21845, G21845, B21845, nowordwrap;
	fontset = print, "Courier", 12, L2, nowordwrap;
	fontset = info, "Courier", 12, L2, nowordwrap;
	fontset = postscript, "Courier", 12, L2, nowordwrap;
	fontset = name, "Times-Italic", 11, L2, italic, R21845, G21845, B21845, nowordwrap, nohscroll;
	fontset = header, "Times", 10, L2;
	fontset = footer, "Times", 12, L2, center;
	fontset = help, "Times-Roman", 13, L2, nohscroll;
	fontset = clipboard, "New York", 12, L2;
	fontset = completions, "Courier", 16, L2, nowordwrap;
	fontset = network, "Courier", 10, L2, nowordwrap;
	fontset = graphlabel, "Courier", 12, L2, nowordwrap;
	fontset = special1, "New York", 12, L2, nowordwrap;
	fontset = special2, "New York", 12, L2, center, nowordwrap;
	fontset = special3, "New York", 12, L2, right, nowordwrap;
	fontset = special4, "New York", 12, L2, nowordwrap;
	fontset = special5, "New York", 12, L2, nowordwrap;]
:[font = title; inactive; ]
Formatting of Tensors
:[font = text; inactive; ]
This example comes from subsection 9.1.3.
:[font = subsubsection; inactive; locked; startGroup; Cclosed; ]
Copyright Notice
:[font = smalltext; inactive; locked; endGroup; ]

	Copyright 1989 by Roman Maeder.
	
	Adapted from	Roman E. Maeder: Programming in Mathematica, Addison-Wesley, 1989.
	
	Permission is hereby granted to make copies of	this file for any purpose other than direct profit,	or as part of a commercial product, provided this copyright notice is left intact.	Sale, other than for the cost of media, is prohibited.
	
	Permission is hereby granted to reproduce part or all of this file provided that the source is acknowledged.

:[font = section; inactive; startGroup; Cclosed; ]
Examples
:[font = subsection; inactive; startGroup; Cclosed; ]
Output Form for Tensors
:[font = text; inactive; ]
The definitions in this package do not perform any computations, they simply define output forms for tensors.
:[font = input; ]
Tensor[Gamma][li[k], ui[i], ui[j]][x, y, z, t]
:[font = input; endGroup; ]
Tensor[R][li[ik], li[j], ui[k], ui[l]]
:[font = subsection; inactive; startGroup; Cclosed; ]
TeX Form of Tensors
:[font = text; inactive; ]
This example is the topic of exercise 10. If you want to solve this exercise, you should not peek in the implementation part below!
:[font = input; ]
TeXForm[ Tensor[Gamma][li[k], ui[i], ui[j]][x, y, z, t] ]
:[font = text; inactive; ]
We see, that we should also define a TeXForm for Gamma
:[font = input; ]
Unprotect[Gamma];
Format[ Gamma, TeXForm ] = "\\Gamma";
Protect[Gamma];
:[font = input; endGroup; endGroup; ]
TeXForm[ Tensor[Gamma][li[k], ui[i], ui[j]][x, y, z, t] ]
:[font = section; inactive; startGroup; Cclosed; ]
Implementation
:[font = input; initialization; ]
*)
BeginPackage["RMPackages`Tensors`"]
(*
:[font = input; initialization; ]
*)
ui::usage = "ui[index] denotes an upper index in a tensor."
li::usage = "li[index] denotes a lower index in a tensor."
Tensor::usage = "Tensor[h][indices] denotes a tensor h with index list indices."
(*
:[font = input; initialization; ]
*)
Begin["`Private`"]
(*
:[font = text; inactive; startGroup; Cclosed; ]
Output Form
:[font = input; initialization; endGroup; ]
*)
Format[ Tensor[t_][ind___] ] :=
	Block[{indices},
		indices = {ind} /. {ui->Superscript, li->Subscript};
		SequenceForm[t, Sequence @@ indices]
	] 
(*
:[font = text; inactive; startGroup; Cclosed; ]
TeX Form
:[font = input; initialization; endGroup; ]
*)
Format[ Tensor[t_][ind___], TeXForm ] :=
	Block[{indices},
		indices = {ind} /. {ui->Superscript, li->Subscript};
		indices = Transpose[{Table["{}", {Length[indices]}], indices}];
		SequenceForm[t, Sequence @@ Flatten[indices, 1]]
	] 
(*
:[font = input; initialization; ]
*)
End[]
(*
:[font = input; initialization; endGroup; ]
*)
EndPackage[]
(*
^*)